searchData={"content_type":"text/markdown","items":[{"doc":"Funkspector is a web scraper that lets you extract data from web pages.","ref":"Funkspector.html","title":"Funkspector","type":"module"},{"doc":"Parses an HTML document.\n\nThis can be used to request a document by passing its URL, like:\n\n  Funkspector.page_scrape(\"https://example.com\")\n\nOr to scrape an already loaded document, by passing its HTML contents:\n\n  Funkspector.page_scrape(\"https://example.com\", contents: \" ... \")","ref":"Funkspector.html#page_scrape/2","title":"Funkspector.page_scrape/2","type":"function"},{"doc":"iex> { :ok, document } = Funkspector.page_scrape(\"https://jaimeiniesta.com\")\n    iex> Enum.take(document.data.links.http.external, 3)\n    [\"http://www.archive.elixirconf.eu/elixirconf2016\", \"https://steadyhq.com/\", \"https://stuart.com/\"]","ref":"Funkspector.html#page_scrape/2-example-request-a-document","title":"Example: request a document - Funkspector.page_scrape/2","type":"function"},{"doc":"iex> Funkspector.page_scrape(\"https://notfoundwebsite.com\")\n    {:error, \"https://notfoundwebsite.com\", %HTTPoison.Error{reason: :nxdomain, id: nil}}","ref":"Funkspector.html#page_scrape/2-example-site-not-found","title":"Example: site not found - Funkspector.page_scrape/2","type":"function"},{"doc":"Given a URL, it will follow the redirections and return the final URL and the final response.","ref":"Funkspector.html#resolve/2","title":"Funkspector.resolve/2","type":"function"},{"doc":"iex> { :ok, final_url, _response } = Funkspector.resolve(\"http://github.com\")\n    iex> final_url\n    \"https://github.com/\"","ref":"Funkspector.html#resolve/2-examples","title":"Examples - Funkspector.resolve/2","type":"function"},{"doc":"","ref":"Funkspector.html#scrape/3","title":"Funkspector.scrape/3","type":"function"},{"doc":"Parses an XML sitemap.\n\nThis can be used to request a document by passing its URL, like:\n\n  Funkspector.sitemap_scrape(\"https://example.com\")\n\nOr to scrape an already loaded document, by passing its XML contents:\n\n  Funkspector.sitemap_scrape(\"https://example.com/sitemap.xml\", contents: \" ... \")","ref":"Funkspector.html#sitemap_scrape/2","title":"Funkspector.sitemap_scrape/2","type":"function"},{"doc":"iex> { :ok, document } = Funkspector.sitemap_scrape(\"https://rocketvalidator.com/sitemap.xml\")\n    iex> length document.data.locs\n    1416\n    iex> Enum.take(document.data.locs, 3)\n    [\"https://rocketvalidator.com/\", \"https://rocketvalidator.com/who\", \"https://rocketvalidator.com/html-validation\"]","ref":"Funkspector.html#sitemap_scrape/2-example","title":"Example - Funkspector.sitemap_scrape/2","type":"function"},{"doc":"Parses a text sitemap.\n\nThis can be used to request a document by passing its URL, like:\n\n  Funkspector.text_sitemap_scrape(\"https://example.com\")\n\nOr to scrape an already loaded document, by passing its text contents:\n\n  Funkspector.text_sitemap_scrape(\"https://example.com/sitemap.txt\", contents: \"...\")","ref":"Funkspector.html#text_sitemap_scrape/2","title":"Funkspector.text_sitemap_scrape/2","type":"function"},{"doc":"iex> { :ok, document } = Funkspector.text_sitemap_scrape(\"https://rocketvalidator.com/sitemap.txt\")\n    iex> length document.data.lines\n    1416\n    iex> Enum.take(document.data.lines, 3)\n    [\"https://rocketvalidator.com/\", \"https://rocketvalidator.com/who\", \"https://rocketvalidator.com/html-validation\"]","ref":"Funkspector.html#text_sitemap_scrape/2-example","title":"Example - Funkspector.text_sitemap_scrape/2","type":"function"},{"doc":"Defines the Document struct and functions to request or load its contents.","ref":"Funkspector.Document.html","title":"Funkspector.Document","type":"module"},{"doc":"Returns a document with the given url and contents.","ref":"Funkspector.Document.html#load/2","title":"Funkspector.Document.load/2","type":"function"},{"doc":"Retrieves the url and returns a document with its contents.","ref":"Funkspector.Document.html#request/2","title":"Funkspector.Document.request/2","type":"function"},{"doc":"Scrapes an HTML page.","ref":"Funkspector.PageScraper.html","title":"Funkspector.PageScraper","type":"module"},{"doc":"Scrapes the Document contents and returns the data scraped from its HTML.","ref":"Funkspector.PageScraper.html#scrape/1","title":"Funkspector.PageScraper.scrape/1","type":"function"},{"doc":"Provides a method to follow URL redirections, returning the final URL.","ref":"Funkspector.Resolver.html","title":"Funkspector.Resolver","type":"module"},{"doc":"Given a URL, it will follow the redirections and return the final URL and the final response.","ref":"Funkspector.Resolver.html#resolve/2","title":"Funkspector.Resolver.resolve/2","type":"function"},{"doc":"iex> { :ok, final_url, _response } = Funkspector.Resolver.resolve(\"http://github.com\")\n    iex> final_url\n    \"https://github.com/\"","ref":"Funkspector.Resolver.html#resolve/2-examples","title":"Examples - Funkspector.Resolver.resolve/2","type":"function"},{"doc":"Scrapes an XML sitemap.","ref":"Funkspector.SitemapScraper.html","title":"Funkspector.SitemapScraper","type":"module"},{"doc":"Scrapes the Document contents and returns the data scraped from its XML.","ref":"Funkspector.SitemapScraper.html#scrape/1","title":"Funkspector.SitemapScraper.scrape/1","type":"function"},{"doc":"Scrapes a text sitemap.","ref":"Funkspector.TextSitemapScraper.html","title":"Funkspector.TextSitemapScraper","type":"module"},{"doc":"Scrapes the Document contents and returns the data scraped from the text lines.","ref":"Funkspector.TextSitemapScraper.html#scrape/1","title":"Funkspector.TextSitemapScraper.scrape/1","type":"function"},{"doc":"Common functionality for the scrapers.","ref":"Funkspector.Utils.html","title":"Funkspector.Utils","type":"module"},{"doc":"Given a collection of URLs and a base URL, absolutifies the relative links.","ref":"Funkspector.Utils.html#absolutify/2","title":"Funkspector.Utils.absolutify/2","type":"function"},{"doc":"iex> Funkspector.Utils.absolutify([\"javascript:alert(hi)\", \"/faqs?section=legal\", \"/about\", \"http://example.com/faqs\"], \"http://example.com\")\n    [\"javascript:alert(hi)\", \"http://example.com/faqs?section=legal\", \"http://example.com/about\", \"http://example.com/faqs\"]","ref":"Funkspector.Utils.html#absolutify/2-examples","title":"Examples - Funkspector.Utils.absolutify/2","type":"function"},{"doc":"Returns a boolean telling if the URL seems valid according to the regexp.","ref":"Funkspector.Utils.html#valid_url?/1","title":"Funkspector.Utils.valid_url?/1","type":"function"},{"doc":"iex> Funkspector.Utils.valid_url?(\"https://example.com\")\ntrue\n\niex> Funkspector.Utils.valid_url?(\"joe@example.com\")\nfalse\n\niex> Funkspector.Utils.valid_url?(nil)\nfalse\n\niex> Funkspector.Utils.valid_url?(\"  \")\nfalse","ref":"Funkspector.Utils.html#valid_url?/1-examples","title":"Examples - Funkspector.Utils.valid_url?/1","type":"function"}]}